/***************************************************************
*                                                              *
*   This file is part of the Geneid-3 Distribution             *
*   (c) by Enrique Blanco, Moises Burset and                   *
*   Roderic Guigo, 1999                                        *
*                                                              *
*   Module: BuildSort                                          *
*                                                              *
*   Building of sorting by donor position of a list of exons   *
***************************************************************/

#include "geneid.h"

void BuildSort(dict *D, int nc[], int ne[], int UC[][MAXENTRY], 
	       int DE[][MAXENTRY], int nclass, long km[], 
	       exonGFF* **d, exonGFF *E, long nexons)
{
  long i,k;
  int j;
  int type;
  int class;
  char aux[MAXTYPE+1];

  /* Each exon will be classified for every sorting function */
  for(i=0; i < nexons; i++)
    {
      aux[0]='\0';
      strcpy (aux, (E+i)->Type);
      strcat (aux, &((E+i)->Strand));

      /* What's the type of exon ? Type+Strand */
      type = getkeyDict(D,aux);
      
      if (type!=NOTFOUND)
	{
	  /* every exon belongs to some upstream compatible classes */
	  for(j=0; j < nc[type]; j++)
	    {
	      class = UC[type][j];
	      k = km[class]-1;
	      
	      /* scanning the exons sorted before: Sorting by Insertion */
	      while (k>=0 && (((E+i)->Donor->Position + (E+i)->offset2) 
			      < 
			      (d[class][k]->Donor->Position 
			       + d[class][k]->offset2)))  
		{
		  d[class][k+1] = d[class][k];
		  k--;
		}
	      d[class][k+1] = (E+i);
	      km[class]++;
	    }
	}
    }
}




