/***************************************************************
*                                                              *
*   This file is part of the Geneid-3 Distribution             *
*   (c) by Enrique Blanco, Moises Burset and                   *
*   Roderic Guigo, 1999                                        *
*                                                              *
*   Module: CorrectExon                                        *
*                                                              *
*   Recompute splice sites positions according to its type     *
***************************************************************/

#include "geneid.h"

void CorrectExon(exonGFF *e) 
{
  /* Correct positions of Begin & End of this Exon */
  e->offset1 =
    ((!strcmp(e->Type,"Terminal") || !strcmp(e->Type,"Single") 
      || !strcmp(e->Type,"TGA_STOP"))
     && e->Strand =='-') ? 
    -LENGTHCODON + COFFSET : +COFFSET;
  
  e->offset2 = 
    ((!strcmp(e->Type,"Terminal") || !strcmp(e->Type,"Single")
      || !strcmp(e->Type,"TGA_STOP"))
     && e->Strand =='+')? 
    LENGTHCODON + COFFSET : +COFFSET;
}
