/***************************************************************
*                                                              *
*   This file is part of the Geneid-3 Distribution             *
*   (c) by Enrique Blanco, Moises Burset and                   *
*   Roderic Guigo, 1999                                        *
*                                                              *
*   Module: FetchSequence                                      *
*                                                              *
*   Put every base to upper letter and reverse sequence        *
***************************************************************/

#include "geneid.h"

int complement(int c)
{

  switch (c) {
      case 'A':
        return('T');
      case 'C':
        return('G');
      case 'G':
        return('C');
      case 'T':
        return('A');
      default:
        return('N');
      }
}

/* Puts upper letters and reverse/complement a DNA sequence */
long FetchSequence(char *s, char* r)
{
  long i,j;
  long l;

  l = strlen(s);
  for (i = 0, j = l-1; i <= j; i++, j--)
    {    
      /* Upper case */
      if (s[i] > 96)
         s[i] = s[i] - 32;
      if (s[j] > 96)
         s[j] = s[j] - 32;

      /* Reverse */
      r[i]=complement(s[j]);
      r[j]=complement(s[i]);
    }
  r[l] = '\0';

 return (l);
}

/* Reverse a split of the original sequence */
void ReverseSubSequence(long p1, long p2, char* s, char* r)
{
  long i,j;
  long l;

  l = p2 - p1 + 1;
  for (i = p1, j = p1 + (l-1); i <= j; i++, j--)
    {    
      /* Reverse */
      r[i-p1]=complement(s[j]);
      r[j-p1]=complement(s[i]);
    }
}

