/***************************************************************
*                                                              *
*   This file is part of the Geneid-3 Distribution             *
*   (c) by Enrique Blanco, Moises Burset and                   *
*   Roderic Guigo, 1999                                        *
*                                                              *
*   Module: SearchEvidenceExons                                *
*                                                              *
*   Searching evidence exons between (l1, l2)                  *
***************************************************************/


#include "geneid.h"

long SearchEvidenceExons(packEvidence* pv, long l2)
{
  long i;
  
  i = pv->i1vExons;
  while ((i < pv->nvExons) && ((pv->vExons+i)->Acceptor->Position) < l2)
    i++;
    
  pv->i2vExons = i;

  return(pv->i2vExons - pv->i1vExons);
}

void SwitchCounters(packEvidence* pv)
{
  pv->i1vExons = pv->i2vExons;
}
