/***************************************************************
*                                                              *
*   This file is part of the Geneid-3 Distribution             *
*   (c) by Enrique Blanco, Moises Burset and                   *
*   Roderic Guigo, 1999                                        *
*                                                              *
*   Module: SwitchPositions                                    *
*                                                              *
*   GeneId needs donor position > acceptor position            *
***************************************************************/

#include "geneid.h"

void SwitchPositions(packExons *allExons) 
{
  long i;
  site *c;
 
  for (i=0;i<allExons->nInitialExons;i++) 
    {
      c = (allExons->InitialExons+i)->Acceptor; 
      (allExons->InitialExons+i)->Acceptor = 
	(allExons->InitialExons+i)->Donor;
      (allExons->InitialExons+i)->Donor = c;
    }

  for (i=0;i<allExons->nInternalExons;i++) 
    {
      c = (allExons->InternalExons+i)->Acceptor; 
      (allExons->InternalExons+i)->Acceptor = 
	(allExons->InternalExons+i)->Donor;
      (allExons->InternalExons+i)->Donor = c;
    }

  for (i=0;i<allExons->nTerminalExons;i++) 
    {
      c = (allExons->TerminalExons+i)->Acceptor; 
      (allExons->TerminalExons+i)->Acceptor = 
	(allExons->TerminalExons+i)->Donor;
      (allExons->TerminalExons+i)->Donor = c;
    }

  for (i=0;i<allExons->nSingles;i++) 
    {
      c = (allExons->Singles+i)->Acceptor; 
      (allExons->Singles+i)->Acceptor = 
	(allExons->Singles+i)->Donor;
      (allExons->Singles+i)->Donor = c;
    }

  for (i=0;i<allExons->nTGAxGTs;i++) 
    {
      c = (allExons->TGAxGT+i)->Acceptor; 
      (allExons->TGAxGT+i)->Acceptor = 
	(allExons->TGAxGT+i)->Donor;
      (allExons->TGAxGT+i)->Donor = c;
    }

  for (i=0;i<allExons->nTGAxSTOPs;i++) 
    {
      c = (allExons->TGAxSTOP+i)->Acceptor; 
      (allExons->TGAxSTOP+i)->Acceptor = 
	(allExons->TGAxSTOP+i)->Donor;
      (allExons->TGAxSTOP+i)->Donor = c;
    } 
}

   
