/*
  this file is part of the geneid-3 distribution
  (c) by Enrique Blanco, 1999

   ScanSequence.c
   Reads DNA sequence and prints all the positions
*/

#include <stdio.h>

#define SEQLENGTH 50000000
#define MAXSTRING 100

long ReadSequence (FILE* seqfile, char* Locus, char* Sequence)
{
  long pos;
  int res;
  char cAux;

  /* line has the locus of the current sequence */
  fscanf(seqfile,">%s", Locus);
  
  /* Jumping until \n of the first fasta line */
  res = fscanf(seqfile,"%c",&cAux);
  while(cAux != '\n')
    res = fscanf(seqfile,"%c",&cAux);

  /* fasta format = "atcgata...atta\n" */
  pos = 0;
  res = fscanf(seqfile,"%s\n",Sequence);
  
  /* Only one sequence can be read */
  while(res != EOF) 
    { 
      pos = pos + strlen(Sequence + pos);
      res = fscanf(seqfile,"%s\n",Sequence + pos);

      if ( !(pos % 100000) )
	fprintf(stderr,"...%ld bp\n",pos);
    }

  /* End of sequence */
  pos = pos + strlen(Sequence + pos);

  return(pos);
}

void ScanSequence (FILE *file, long iant,long ipost)
{
  long i;
  long LengthSequence;
  char LocusName[MAXSTRING];
  char *Sequence;

  Sequence = (char *) calloc(SEQLENGTH,sizeof(char));

  LengthSequence = ReadSequence(file,LocusName,Sequence);
  printf("This ADN sequence is %s (%ld nucleotids)\n",
	 LocusName, LengthSequence);
    
  for(i=iant; i<=ipost; i++)
	printf("Position %ld: %c\n",i+1,Sequence[i]);
}

main(int argc, char *argv[])
{
  long iant,ipost;
  FILE *file;
  
  if (argc != 4)
    {
      fprintf(stderr,"ss <.fasta> <pos1> <pos2> \n");
      exit(1);
    }
  if ((file=fopen(argv[1], "r"))==NULL)
    {
      fprintf(stderr,"The file %s cannot be open for read\n",argv[1]);
      exit(1);
    }
  ScanSequence(file,atol(argv[2])-1,atol(argv[3])-1);
}












